#include <linux/init.h>
#include <linux/module.h>
#include <linux/fs.h>
#include <linux/proc_fs.h>
#include <linux/miscdevice.h>
#include <linux/ioport.h>//захват портов ввода-вывода
#include <linux/interrupt.h>//Захват прерывания
#include <asm/io.h>
#include <asm/uaccess.h>

MODULE_LICENSE("GPL");
MODULE_AUTHOR("Kurenya");
MODULE_VERSION("0.5");

#define DEV_NAME "ISA_TIME"
//Порты ввода-вывода устройства
#define PORT_START0 0x320
#define PORT_COUNT0 16
//Номер прерывания
#define IRQ_NUM 3
#define BUF_LEN 80

static char str[]="day 000 run 00 hour 00 min 00 sec 00 msec 0000 irq 0\n";//buffer!
static unsigned int len;
//static char Message[BUF_LEN];
static atomic_t Device_Open=ATOMIC_INIT(0);
static u16 set0,set1,set2,set3,den,tmp,chas,min,sec,msec,mksec,run,irqgen;
static u16 irqgen,mask;
static u32 irq=IRQ_NUM,my_dev_id;
static ssize_t returned;

//опережающее описание функций
static int device_open(struct inode *,struct file *);
static int device_release(struct inode *,struct file *);
//static ssize_t device_read(struct file *,char *,size_t,loff_t *);
//static ssize_t device_write(struct file *,const char *,size_t,loff_t *);
//static loff_t device_seek(struct file *,loff_t,int);
static ssize_t proc_node_read(char *,char **,off_t,int,int *,void *);
/*
static const struct file_operations fops={
  .owner=THIS_MODULE,
  .read=device_read,
//  .write=device_write,
  .llseek=device_seek,
  .open=device_open,
  .release=device_release
};
/**/
static irqreturn_t ISATIME_irq_handler(int irq,void *dev_id){
set3=inw(0x326);
irqgen=set3>>12;
if(irqgen>0){
  set0=inw(0x320);
  set1=inw(0x322);
  set2=inw(0x324);
  den=((set0>>14)&0x3)*100+((set0>>10)&0xf)*10+((set0>>6)&0xf);
  tmp=((set0&0x3)<<2)|((set1>>14)&0x3);
  chas=tmp+((set0>>2)&0x3)*10;
  min=((set1>>10)&0x7)*10+((set1>>6)&0xf);
  tmp=((set1&0x3)<<2)|((set2>>14)&0x3);
  sec=((set1>>2)&0x7)*10+tmp;
  msec=((set2>>10)&0xf)*100+((set2>>6)&0xf)*10+((set2>>2)&0xf);
  mksec=set3&0xf;
  run=chas*4;
  if(min<15)             run=run+1;
  if((min>=15)&(min< 30))run=run+2;
  if((min>=30)&(min< 45))run=run+3;
  if((min>=45)&(min<=59))run=run+4;
  inw(0x328);
  sprintf(str,"day %03d run %02d hour %02d min %02d sec %02d msec %04d irq %1x\n",den,run,chas,min,sec,msec,irqgen);
  return IRQ_HANDLED;
  }else{
  return IRQ_NONE;
  };
}

static int __init dev_init(void){
len=strlen(str);

//if(proc_create(DEV_NAME,0,NULL,&fops)==NULL){
//  printk("ISA module : Unable to register ISA_proc device\n");
//  return -EBUSY;
//  };
if(create_proc_read_entry(DEV_NAME,0,NULL,proc_node_read,NULL)==0){
  //printk( KERN_ERR "can't create /proc/%s\n", NAME_NODE );
  return -ENOMEM;
  };
printk("ISA module : Registered ISA_dev device\n");
if(check_region(PORT_START0,PORT_COUNT0)){
  printk("ISA module : Allocation io ports failed\n");
  remove_proc_entry(DEV_NAME,NULL);
  return -EBUSY;
  };
printk("ISA module : Registered IOport region\n");
request_region(PORT_START0,PORT_COUNT0,DEV_NAME);
if(request_irq(irq,ISATIME_irq_handler,IRQF_SHARED,DEV_NAME,&my_dev_id)){
  printk("ISA module : IRQ allocation failed\n");
  release_region(PORT_START0,PORT_COUNT0);
  remove_proc_entry(DEV_NAME,NULL);
  return -EBUSY;
  };
printk("ISA module : Registered IRQ handler\n");
mask=
//запись 1 маскирует прерывание
0x1000|//15 min
0x2000|//Sec
//0x4000|//mS
0x8000|//Fix
0x0000;
inw(0x328);
outw(mask,0x32c);
inw(0x328);
inw(0x320);
inw(0x322);
inw(0x324);
inw(0x326);
inw(0x328);
enable_irq(irq);
return 0;
}

static void __exit dev_exit(void){
mask=0xf000;//маскируем все прерывания
inw(0x328);
outw(mask,0x32c);
inw(0x328);
inw(0x320);
inw(0x322);
inw(0x324);
inw(0x326);
inw(0x328);
synchronize_irq(irq);
disable_irq(irq);
free_irq(irq,&my_dev_id);
printk("ISA module : release irq\n");
release_region(PORT_START0,PORT_COUNT0);
printk("ISA module : release io ports\n");
remove_proc_entry(DEV_NAME,NULL);
printk("ISA module : unregistred ISA_dev device\n");
}

static int device_open(struct inode *inode,struct file *filep)
{
//if(atomic_read(&Device_Open)>=2)return -EBUSY;
atomic_inc(&Device_Open);
try_module_get(THIS_MODULE);
return 0;
}

static int device_release(struct inode *inode,struct file *filep)
{
if(atomic_read(&Device_Open)==0)return -EBUSY;
atomic_dec(&Device_Open);/*Теперь мы готовы обслужить другой процесс*/
//Уменьшить счетчик обращений, иначе, после первой же удачной попытки открыть файл устройства,
//вы никогда не сможете выгрузить модуль. 
module_put(THIS_MODULE);
return 0;
}
/*
static ssize_t device_read(struct file * file,char * buf,size_t count,loff_t *ppos){
if(count<len)return -EINVAL;
//if(*ppos!=0){return 0;};
if(copy_to_user((void*)buf,str,len))return -EINVAL;
//printk("ISA module : copy to user Ok\n");
*ppos=len+1;
//*ppos=0;
returned=count;
return returned;
}
/**/
static ssize_t proc_node_read(char *buffer,char **start,off_t off,int count,int *eof,void *data){
  static int offset=0,i;
  //printk( KERN_INFO "read: %d\n", count );
  for(i=0;(offset<=len)&&('\0'!=str[offset]);offset++,i++)
    *(buffer+i)=str[offset];
  *(buffer+i)='\n';
  i++;
  if((offset>=len)||('\0'==str[offset])){
    offset=0;
    *eof=1;
  }else{
    *eof=0;
  };
  //printk( KERN_INFO "return bytes: %d\n", i );
  //if(*eof!=0)printk(KERN_INFO "EOF\n");
  return i;
};

/*
static ssize_t device_write(struct file *filp,const char *buff,size_t len,loff_t * off)
{
disable_irq(irq);
for(i=0;i<len && i<BUF_LEN;i++)get_user(Message[i],buff+i);
switch(Message[0]){
  case 0x0:mask=0x0000^0xf000;break;
  case 0x1:mask=0x1000^0xf000;break;
  case 0x2:mask=0x2000^0xf000;break;
  case 0x3:mask=0x3000^0xf000;break;
  case 0x4:mask=0x4000^0xf000;break;
  case 0x5:mask=0x5000^0xf000;break;
  case 0x6:mask=0x6000^0xf000;break;
  case 0x7:mask=0x7000^0xf000;break;
  case 0x8:mask=0x8000^0xf000;break;
  case 0x9:mask=0x9000^0xf000;break;
  case 0xa:mask=0xa000^0xf000;break;
  case 0xb:mask=0xb000^0xf000;break;
  case 0xc:mask=0xc000^0xf000;break;
  case 0xd:mask=0xd000^0xf000;break;
  case 0xe:mask=0xe000^0xf000;break;
  case 0xf:mask=0xf000^0xf000;break;
  case '0':mask=0x0000^0xf000;break;
  case '1':mask=0x1000^0xf000;break;
  case '2':mask=0x2000^0xf000;break;
  case '3':mask=0x3000^0xf000;break;
  case '4':mask=0x4000^0xf000;break;
  case '5':mask=0x5000^0xf000;break;
  case '6':mask=0x6000^0xf000;break;
  case '7':mask=0x7000^0xf000;break;
  case '8':mask=0x8000^0xf000;break;
  case '9':mask=0x9000^0xf000;break;
  case 'a':mask=0xa000^0xf000;break;
  case 'b':mask=0xb000^0xf000;break;
  case 'c':mask=0xc000^0xf000;break;
  case 'd':mask=0xd000^0xf000;break;
  case 'e':mask=0xe000^0xf000;break;
  case 'f':mask=0xf000^0xf000;break;
  default :mask=0xf000;break;
  };
inw(0x328);
outw(mask,0x32c);
inw(0x328);
inw(0x320);
inw(0x322);
inw(0x324);
inw(0x326);
inw(0x328);
enable_irq(irq);
return (ssize_t)i;
}
/**/
/*
static loff_t device_seek(struct file *fl,loff_t offset,int whence)
{
static loff_t newpos;
switch(whence){
  case 0://SEEK_SET
    newpos=offset;
    break;
  case 1://SEEK_CUR
    newpos=fl->f_pos+offset;
    break;
  case 2://SEEK_END
    newpos=len+offset;
    break;
  default:return -EINVAL;
  };
if(newpos<0)newpos=0;
if(newpos>len)newpos=0;
return newpos;
}
/**/
static int __init dev_init(void);
module_init(dev_init);

static void __exit dev_exit(void);
module_exit(dev_exit);
